{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": "hostname",
            "stdout": "result.host.txt",
            "inputs": [
                {
                    "type": [
                        "int",
                        "File"
                    ],
                    "id": "#host.hostname.tool.cwl/iteration"
                }
            ],
            "id": "#host.hostname.tool.cwl",
            "outputs": [
                {
                    "type": "File",
                    "id": "#host.hostname.tool.cwl/result",
                    "outputBinding": {
                        "glob": "result.host.txt"
                    }
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": "echo",
            "inputs": [
                {
                    "type": "int",
                    "id": "#host.serialize.tool.cwl/ntimes"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "int"
                    },
                    "outputBinding": {
                        "outputEval": "${\n  var out = []\n  for(var i = 0; i < inputs.ntimes; i++) {\n    out.push(i)\n  }\n  return out\n }"
                    },
                    "id": "#host.serialize.tool.cwl/range"
                }
            ],
            "id": "#host.serialize.tool.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "sort",
            "arguments": [
                "-u"
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#host.sort.tool.cwl/logfile"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "prefix": null
                    },
                    "id": "#host.sort.tool.cwl/names1"
                },
                {
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "File"
                        }
                    ],
                    "inputBinding": {
                        "prefix": null
                    },
                    "id": "#host.sort.tool.cwl/names2"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#host.sort.tool.cwl/hosts",
                    "outputBinding": {
                        "glob": "$(inputs.logfile)"
                    }
                }
            ],
            "stdout": "$(inputs.logfile)",
            "id": "#host.sort.tool.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "MultipleInputFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "string",
                    "id": "#main/logfile2"
                },
                {
                    "type": "int",
                    "id": "#main/ntasks"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/catsortStep/hosts",
                    "id": "#main/result"
                }
            ],
            "steps": [
                {
                    "run": "#host.sort.tool.cwl",
                    "in": [
                        {
                            "source": "#main/logfile2",
                            "id": "#main/catsortStep/logfile"
                        },
                        {
                            "source": [
                                "#main/hostStep1/result",
                                "#main/hostStep2/result"
                            ],
                            "linkMerge": "merge_flattened",
                            "id": "#main/catsortStep/names1"
                        }
                    ],
                    "out": [
                        "#main/catsortStep/hosts"
                    ],
                    "id": "#main/catsortStep"
                },
                {
                    "run": "#host.hostname.tool.cwl",
                    "scatter": "#main/hostStep1/iteration",
                    "in": [
                        {
                            "source": "#main/rangeStep/range",
                            "id": "#main/hostStep1/iteration"
                        }
                    ],
                    "out": [
                        "#main/hostStep1/result"
                    ],
                    "id": "#main/hostStep1"
                },
                {
                    "run": "#host.hostname.tool.cwl",
                    "scatter": "#main/hostStep2/iteration",
                    "in": [
                        {
                            "source": "#main/hostStep1/result",
                            "id": "#main/hostStep2/iteration"
                        }
                    ],
                    "out": [
                        "#main/hostStep2/result"
                    ],
                    "id": "#main/hostStep2"
                },
                {
                    "run": "#host.serialize.tool.cwl",
                    "in": [
                        {
                            "source": "#main/ntasks",
                            "id": "#main/rangeStep/ntimes"
                        }
                    ],
                    "out": [
                        "#main/rangeStep/range"
                    ],
                    "id": "#main/rangeStep"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
